<!DOCTYPE html>

<html lang="en" data-content_root="../../">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>helpers.get_by_doi &#8212; NLP004  documentation</title>
    <link rel="stylesheet" type="text/css" href="../../_static/pygments.css?v=4f649999" />
    <link rel="stylesheet" type="text/css" href="../../_static/alabaster.css?v=039e1c02" />
    <script src="../../_static/documentation_options.js?v=5929fcd5"></script>
    <script src="../../_static/doctools.js?v=888ff710"></script>
    <script src="../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <link rel="index" title="Index" href="../../genindex.html" />
    <link rel="search" title="Search" href="../../search.html" />
   
  <link rel="stylesheet" href="../../_static/custom.css" type="text/css" />
  
  
  <meta name="viewport" content="width=device-width, initial-scale=0.9, maximum-scale=0.9" />

  </head><body>
  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          

          <div class="body" role="main">
            
  <h1>Source code for helpers.get_by_doi</h1><div class="highlight"><pre>
<span></span><span class="kn">import</span> <span class="nn">sys</span>
<span class="kn">import</span> <span class="nn">csv</span>
<span class="kn">import</span> <span class="nn">os</span>
<span class="kn">import</span> <span class="nn">re</span>
<span class="kn">import</span> <span class="nn">ssl</span>
<span class="kn">import</span> <span class="nn">subprocess</span>
<span class="kn">import</span> <span class="nn">xml.etree.ElementTree</span> <span class="k">as</span> <span class="nn">ET</span>
<span class="kn">from</span> <span class="nn">io</span> <span class="kn">import</span> <span class="n">BytesIO</span>
<span class="kn">from</span> <span class="nn">lxml</span> <span class="kn">import</span> <span class="n">etree</span>
<span class="kn">import</span> <span class="nn">requests</span>
<span class="kn">import</span> <span class="nn">json</span>
<span class="kn">import</span> <span class="nn">time</span>

<span class="n">sys</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">append</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="vm">__file__</span><span class="p">)))</span>
<span class="kn">from</span> <span class="nn">helper_functions</span> <span class="kn">import</span> <span class="n">doi_to_filename</span>


<span class="k">def</span> <span class="nf">xml_to_txt</span><span class="p">(</span><span class="n">xml_path</span><span class="p">):</span>
    <span class="n">tree</span> <span class="o">=</span> <span class="n">ET</span><span class="o">.</span><span class="n">parse</span><span class="p">(</span><span class="n">xml_path</span><span class="p">)</span>
    <span class="n">root</span> <span class="o">=</span> <span class="n">tree</span><span class="o">.</span><span class="n">getroot</span><span class="p">()</span>
    <span class="n">text</span> <span class="o">=</span> <span class="nb">list</span><span class="p">(</span><span class="n">root</span><span class="o">.</span><span class="n">itertext</span><span class="p">())</span>
    <span class="k">return</span> <span class="s2">&quot;</span><span class="se">\n</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">text</span><span class="p">)</span>


<div class="viewcode-block" id="get_springer_by_doi">
<a class="viewcode-back" href="../../helpers/get_by_doi.html#helpers.get_by_doi.get_springer_by_doi">[docs]</a>
<span class="k">def</span> <span class="nf">get_springer_by_doi</span><span class="p">(</span><span class="n">doi</span><span class="p">,</span> <span class="n">out_dir</span><span class="p">,</span> <span class="n">api_key</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        get data from Springer</span>
<span class="sd">        see: https://dev.springernature.com/restfuloperations</span>
<span class="sd">    &quot;&quot;&quot;</span>

    <span class="n">json_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">out_dir</span><span class="p">,</span> <span class="n">doi_to_filename</span><span class="p">(</span><span class="n">doi</span><span class="p">,</span> <span class="s2">&quot;json&quot;</span><span class="p">))</span>
    <span class="k">if</span> <span class="ow">not</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">json_path</span><span class="p">):</span>
        <span class="n">url</span> <span class="o">=</span> <span class="s2">&quot;http://api.springernature.com/metadata/json/doi/&quot;</span> <span class="o">+</span> <span class="n">doi</span> <span class="o">+</span> <span class="s2">&quot;?api_key=&quot;</span> <span class="o">+</span> <span class="n">api_key</span>
        <span class="n">response</span> <span class="o">=</span> <span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">url</span><span class="p">)</span>

        <span class="n">json_response</span> <span class="o">=</span> <span class="n">json</span><span class="o">.</span><span class="n">loads</span><span class="p">(</span><span class="n">response</span><span class="o">.</span><span class="n">text</span><span class="p">)</span>
        <span class="n">json_response</span><span class="p">[</span><span class="s1">&#39;apiKey&#39;</span><span class="p">]</span> <span class="o">=</span> <span class="s1">&#39;yourKeyHere&#39;</span>
        
        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">json_path</span><span class="p">,</span> <span class="s1">&#39;w&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">output_file</span><span class="p">:</span>
            <span class="n">json</span><span class="o">.</span><span class="n">dump</span><span class="p">(</span><span class="n">json_response</span><span class="p">,</span> <span class="n">output_file</span><span class="p">,</span> <span class="n">indent</span><span class="o">=</span><span class="mi">2</span><span class="p">)</span></div>



<div class="viewcode-block" id="get_wiley_by_doi">
<a class="viewcode-back" href="../../helpers/get_by_doi.html#helpers.get_by_doi.get_wiley_by_doi">[docs]</a>
<span class="k">def</span> <span class="nf">get_wiley_by_doi</span><span class="p">(</span><span class="n">doi</span><span class="p">,</span> <span class="n">out_dir</span><span class="p">,</span> <span class="n">api_key</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        get data from Wiley</span>
<span class="sd">        see: https://onlinelibrary.wiley.com/library-info/resources/text-and-datamining</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">pdf_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">out_dir</span><span class="p">,</span> <span class="n">doi_to_filename</span><span class="p">(</span><span class="n">doi</span><span class="p">,</span> <span class="s2">&quot;pdf&quot;</span><span class="p">))</span>
    <span class="k">if</span> <span class="ow">not</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">pdf_path</span><span class="p">):</span>
        <span class="n">headers</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;Accept&quot;</span><span class="p">:</span> <span class="s2">&quot;application/vnd.crossref.unixsd+xml&quot;</span><span class="p">}</span>
        <span class="n">doi_resolve</span> <span class="o">=</span> <span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s2">&quot;http://dx.doi.org/&quot;</span> <span class="o">+</span> <span class="n">doi</span><span class="p">,</span> <span class="n">headers</span><span class="o">=</span><span class="n">headers</span><span class="p">)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">tree</span> <span class="o">=</span> <span class="n">etree</span><span class="o">.</span><span class="n">parse</span><span class="p">(</span><span class="n">BytesIO</span><span class="p">(</span><span class="n">doi_resolve</span><span class="o">.</span><span class="n">content</span><span class="p">))</span>
        <span class="k">except</span> <span class="ne">BaseException</span><span class="p">:</span> <span class="c1"># [bare-except]</span>
            <span class="nb">print</span><span class="p">(</span><span class="sa">f</span><span class="s2">&quot;🤯 ::: </span><span class="si">{</span><span class="n">doi_resolve</span><span class="o">.</span><span class="n">url</span><span class="si">}</span><span class="s2"> ::: </span><span class="si">{</span><span class="n">doi_resolve</span><span class="o">.</span><span class="n">status_code</span><span class="si">}</span><span class="s2">&quot;</span><span class="p">)</span>
            <span class="k">return</span> <span class="kc">None</span>

        <span class="n">search_term</span> <span class="o">=</span> <span class="s1">&#39;//{*}collection[@property=&quot;text-mining&quot;]&#39;</span> \
                    <span class="o">+</span> <span class="s1">&#39;/{*}item&#39;</span> \
                    <span class="o">+</span> <span class="s1">&#39;/{*}resource&#39;</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">collections</span> <span class="o">=</span> <span class="n">tree</span><span class="o">.</span><span class="n">findall</span><span class="p">(</span> <span class="n">search_term</span> <span class="p">)</span>
            <span class="n">text_url</span> <span class="o">=</span> <span class="n">collections</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">text</span>
        <span class="k">except</span> <span class="ne">IndexError</span><span class="p">:</span>
            <span class="k">try</span><span class="p">:</span>
                <span class="n">collections</span> <span class="o">=</span> <span class="n">tree</span><span class="o">.</span><span class="n">findall</span><span class="p">(</span> <span class="n">search_term</span><span class="o">.</span><span class="n">replace</span><span class="p">(</span><span class="s1">&#39;text-mining&#39;</span><span class="p">,</span> <span class="s1">&#39;crawler-based&#39;</span><span class="p">)</span> <span class="p">)</span>
                <span class="n">text_url</span> <span class="o">=</span> <span class="n">collections</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">text</span>
            <span class="k">except</span> <span class="ne">IndexError</span><span class="p">:</span>
                <span class="c1"># wild guess</span>
                <span class="n">text_url</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;https://onlinelibrary.wiley.com/doi/pdfdirect/</span><span class="si">{</span><span class="n">doi</span><span class="si">}</span><span class="s2">?download=true&quot;</span>


        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">pdf_path</span><span class="p">,</span> <span class="s1">&#39;wb&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">file</span><span class="p">:</span>
            <span class="n">headers</span> <span class="o">=</span> <span class="p">{</span><span class="s1">&#39;Wiley-TDM-Client-Token&#39;</span><span class="p">:</span> <span class="n">api_key</span><span class="p">}</span>
            <span class="n">response</span> <span class="o">=</span> <span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">text_url</span><span class="p">,</span> <span class="n">headers</span><span class="o">=</span><span class="n">headers</span><span class="p">)</span>
            <span class="n">file</span><span class="o">.</span><span class="n">write</span><span class="p">(</span> <span class="n">response</span><span class="o">.</span><span class="n">content</span> <span class="p">)</span></div>


<div class="viewcode-block" id="get_elsevier_by_doi">
<a class="viewcode-back" href="../../helpers/get_by_doi.html#helpers.get_by_doi.get_elsevier_by_doi">[docs]</a>
<span class="k">def</span> <span class="nf">get_elsevier_by_doi</span><span class="p">(</span><span class="n">doi</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">out_dir</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">api_key</span><span class="p">:</span> <span class="nb">str</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        get article metadata and text from big E</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">xml_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">out_dir</span><span class="p">,</span> <span class="n">doi_to_filename</span><span class="p">(</span><span class="n">doi</span><span class="p">,</span> <span class="s2">&quot;xml&quot;</span><span class="p">))</span>
    <span class="k">if</span> <span class="ow">not</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">xml_path</span><span class="p">):</span>
        <span class="n">url</span> <span class="o">=</span> <span class="sa">f</span><span class="s2">&quot;https://api.elsevier.com/content/article/doi/</span><span class="si">{</span><span class="n">doi</span><span class="si">}</span><span class="s2">&quot;</span>
        <span class="n">xml_response</span> <span class="o">=</span> <span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">url</span><span class="p">,</span> <span class="n">params</span><span class="o">=</span><span class="p">{</span><span class="s2">&quot;apiKey&quot;</span><span class="p">:</span> <span class="n">api_key</span><span class="p">})</span>
        <span class="k">if</span> <span class="n">xml_response</span><span class="o">.</span><span class="n">status_code</span> <span class="o">!=</span> <span class="mi">200</span><span class="p">:</span>
            <span class="p">()</span> <span class="c1"># breakpoint</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">xml_path</span><span class="p">,</span> <span class="s2">&quot;w&quot;</span><span class="p">,</span> <span class="n">encoding</span><span class="o">=</span><span class="s1">&#39;UTF-8&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
                <span class="n">f</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="n">xml_response</span><span class="o">.</span><span class="n">text</span><span class="p">)</span></div>

    <span class="c1"># curl &#39;https://api.elsevier.com/content/article/doi/10.1016/j.epsl.2017.03.011?apiKey=d0a1fd53101a8504d0ea26ea570c1254&#39; &gt; elsevier/xml/10.1016_j.epsl.2017.03.011.xml</span>
    <span class="c1"># curl -H &quot;Accept: text/plain&quot; &#39;https://api.elsevier.com/content/article/doi/10.1016/j.epsl.2017.03.011?apiKey=d0a1fd53101a8504d0ea26ea570c1254&#39; &gt; elsevier/txt/10.1016_j.epsl.2017.03.011.txt</span>

<div class="viewcode-block" id="get_by_doi">
<a class="viewcode-back" href="../../helpers/get_by_doi.html#helpers.get_by_doi.get_by_doi">[docs]</a>
<span class="k">def</span> <span class="nf">get_by_doi</span><span class="p">(</span><span class="n">doi</span><span class="p">,</span> <span class="n">out_dir</span><span class="p">,</span> <span class="n">api_key</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        main getter for all DOIs</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">dir_name</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">basename</span><span class="p">(</span><span class="n">out_dir</span><span class="p">)</span>
    <span class="k">if</span> <span class="n">dir_name</span> <span class="o">==</span> <span class="s2">&quot;springer&quot;</span><span class="p">:</span>
        <span class="n">os</span><span class="o">.</span><span class="n">makedirs</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">out_dir</span><span class="p">,</span> <span class="s2">&quot;json&quot;</span><span class="p">),</span> <span class="n">exist_ok</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
        <span class="n">get_springer_by_doi</span><span class="p">(</span><span class="n">doi</span><span class="p">,</span> <span class="n">out_dir</span><span class="p">,</span> <span class="n">api_key</span><span class="p">)</span>
    <span class="k">elif</span> <span class="n">dir_name</span> <span class="o">==</span> <span class="s2">&quot;wiley&quot;</span><span class="p">:</span>
        <span class="n">os</span><span class="o">.</span><span class="n">makedirs</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">out_dir</span><span class="p">,</span> <span class="s2">&quot;pdf&quot;</span><span class="p">),</span> <span class="n">exist_ok</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
        <span class="n">get_wiley_by_doi</span><span class="p">(</span><span class="n">doi</span><span class="p">,</span> <span class="n">out_dir</span><span class="p">,</span> <span class="n">api_key</span><span class="p">)</span>
    <span class="k">elif</span> <span class="n">dir_name</span> <span class="o">==</span> <span class="s2">&quot;elsevier&quot;</span><span class="p">:</span>
        <span class="n">os</span><span class="o">.</span><span class="n">makedirs</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">out_dir</span><span class="p">,</span> <span class="s2">&quot;xml&quot;</span><span class="p">),</span> <span class="n">exist_ok</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
        <span class="n">get_elsevier_by_doi</span><span class="p">(</span><span class="n">doi</span><span class="p">,</span> <span class="n">out_dir</span><span class="p">,</span> <span class="n">api_key</span><span class="p">)</span></div>



<div class="viewcode-block" id="get_publisher">
<a class="viewcode-back" href="../../helpers/get_by_doi.html#helpers.get_by_doi.get_publisher">[docs]</a>
<span class="k">def</span> <span class="nf">get_publisher</span><span class="p">(</span><span class="n">doi</span><span class="p">:</span> <span class="nb">str</span><span class="p">,</span> <span class="n">prefix_dict</span><span class="p">:</span> <span class="nb">dict</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">        returns the publisher name by DOI prefix</span>
<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">prefix</span> <span class="o">=</span> <span class="n">doi</span><span class="o">.</span><span class="n">split</span><span class="p">(</span><span class="s2">&quot;/&quot;</span><span class="p">)[</span><span class="mi">0</span><span class="p">]</span>
    <span class="k">try</span><span class="p">:</span>
        <span class="k">return</span> <span class="n">prefix_dict</span><span class="p">[</span><span class="n">prefix</span><span class="p">]</span>
    <span class="k">except</span> <span class="ne">KeyError</span><span class="p">:</span>
        <span class="k">return</span> <span class="s2">&quot;NIL&quot;</span></div>


<div class="viewcode-block" id="get_doi_prefix_dict">
<a class="viewcode-back" href="../../helpers/get_by_doi.html#helpers.get_by_doi.get_doi_prefix_dict">[docs]</a>
<span class="k">def</span> <span class="nf">get_doi_prefix_dict</span><span class="p">(</span><span class="n">path</span><span class="o">=</span><span class="s1">&#39;&#39;</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&#39;&#39;&#39;</span>
<span class="sd">    Gets doi prefixes to publishers match.</span>

<span class="sd">    Arguments:</span>
<span class="sd">        path (str): Path to csv file with prefix info. Defaults to empty string. Hard coded to read from &#39;../source/doi-prefix-publishers.csv&#39; relative to the script location.</span>

<span class="sd">    Returns:</span>
<span class="sd">        </span>
<span class="sd">        dict: Dictionary of doi_preffix - publisher pairs.</span>
<span class="sd">    &#39;&#39;&#39;</span>
    <span class="k">if</span> <span class="nb">len</span><span class="p">(</span><span class="n">path</span><span class="p">)</span><span class="o">==</span><span class="mi">0</span><span class="p">:</span>
        <span class="n">path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span>
            <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span>
                <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">dirname</span><span class="p">(</span><span class="vm">__file__</span><span class="p">),</span> 
                <span class="s1">&#39;../source/doi-prefix-publishers.csv&#39;</span>
            <span class="p">)</span>
        <span class="p">)</span>

    <span class="n">path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">path</span><span class="p">)</span>
    <span class="n">prefix_dict</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">()</span>
    <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">path</span><span class="p">,</span> <span class="n">newline</span><span class="o">=</span><span class="s1">&#39;&#39;</span><span class="p">,</span> <span class="n">encoding</span><span class="o">=</span><span class="s1">&#39;UTF-8&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">csvfile</span><span class="p">:</span>
        <span class="n">prefix_resolver</span> <span class="o">=</span> <span class="n">csv</span><span class="o">.</span><span class="n">DictReader</span><span class="p">(</span><span class="n">csvfile</span><span class="p">,</span> <span class="n">delimiter</span><span class="o">=</span><span class="s1">&#39;,&#39;</span><span class="p">,</span> <span class="n">quotechar</span><span class="o">=</span><span class="s1">&#39;&quot;&#39;</span><span class="p">)</span>
        <span class="k">for</span> <span class="n">_row</span> <span class="ow">in</span> <span class="n">prefix_resolver</span><span class="p">:</span>
            <span class="n">prefix_dict</span><span class="p">[</span><span class="n">_row</span><span class="p">[</span><span class="s1">&#39;prefix&#39;</span><span class="p">]]</span> <span class="o">=</span> <span class="n">_row</span><span class="p">[</span><span class="s1">&#39;publisher&#39;</span><span class="p">]</span>
    
    <span class="k">return</span> <span class="n">prefix_dict</span></div>


<div class="viewcode-block" id="get_doi_from_req">
<a class="viewcode-back" href="../../helpers/get_by_doi.html#helpers.get_by_doi.get_doi_from_req">[docs]</a>
<span class="k">def</span> <span class="nf">get_doi_from_req</span><span class="p">(</span><span class="n">doi</span><span class="p">,</span> <span class="n">out_dir</span><span class="p">,</span> <span class="n">source</span><span class="o">=</span><span class="s1">&#39;https://oa.mg/work/&#39;</span><span class="p">):</span>
<span class="w">    </span><span class="sd">&#39;&#39;&#39;</span>
<span class="sd">    Gets abstracts from a request and slices out the abstract part from the response.</span>

<span class="sd">    Arguments:</span>
<span class="sd">        doi (str): DOI of a paper, abstract of which is searched</span>
<span class="sd">        source (str): Base url / source to send the request.</span>
<span class="sd">    </span>
<span class="sd">    Returns:</span>

<span class="sd">        bool: True if success, False if fail.</span>
<span class="sd">    &#39;&#39;&#39;</span>

    <span class="n">out_dir</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">out_dir</span><span class="p">)</span>
    <span class="n">os</span><span class="o">.</span><span class="n">makedirs</span><span class="p">(</span><span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">out_dir</span><span class="p">,</span> <span class="s2">&quot;txt&quot;</span><span class="p">),</span> <span class="n">exist_ok</span><span class="o">=</span><span class="kc">True</span><span class="p">)</span>
    <span class="n">txt_path</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">join</span><span class="p">(</span><span class="n">out_dir</span><span class="p">,</span> <span class="n">doi_to_filename</span><span class="p">(</span><span class="n">doi</span><span class="p">,</span> <span class="s2">&quot;txt&quot;</span><span class="p">))</span>
    

    <span class="k">if</span> <span class="ow">not</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">txt_path</span><span class="p">):</span>
        <span class="n">url</span> <span class="o">=</span> <span class="n">source</span><span class="o">+</span><span class="n">doi</span>
        <span class="n">response</span> <span class="o">=</span> <span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="n">url</span><span class="p">)</span>
        <span class="k">if</span> <span class="p">(</span><span class="n">response</span><span class="o">.</span><span class="n">status_code</span> <span class="o">==</span> <span class="mi">200</span> <span class="ow">and</span> <span class="s1">&#39;Loading · OA.mg&#39;</span> <span class="ow">not</span> <span class="ow">in</span> <span class="n">response</span><span class="o">.</span><span class="n">text</span><span class="p">):</span>
            <span class="c1"># abstract = response.text.split(&#39;&quot;abstract&quot;:&#39;)[1].split(&#39;\n&#39;)[0].strip()[1:-1]</span>
            <span class="n">abstract</span> <span class="o">=</span> <span class="n">response</span><span class="o">.</span><span class="n">text</span>
            <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">txt_path</span><span class="p">,</span> <span class="s2">&quot;w&quot;</span><span class="p">,</span> <span class="n">encoding</span><span class="o">=</span><span class="s1">&#39;UTF-8&#39;</span><span class="p">)</span> <span class="k">as</span> <span class="n">file</span><span class="p">:</span>
                <span class="n">file</span><span class="o">.</span><span class="n">write</span><span class="p">(</span><span class="n">abstract</span><span class="p">)</span>
            <span class="k">return</span> <span class="kc">True</span>
        <span class="k">else</span><span class="p">:</span>
            <span class="k">return</span> <span class="kc">False</span></div>

</pre></div>

          </div>
          
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<h1 class="logo"><a href="../../index.html">NLP004</a></h1>








<h3>Navigation</h3>
<p class="caption" role="heading"><span class="caption-text">Contents:</span></p>
<ul>
<li class="toctree-l1"><a class="reference internal" href="../../modules.html">python</a></li>
<li class="toctree-l1"><a class="reference internal" href="../../pipe.html">pipe</a></li>
</ul>

<div class="relations">
<h3>Related Topics</h3>
<ul>
  <li><a href="../../index.html">Documentation overview</a><ul>
  <li><a href="../index.html">Module code</a><ul>
  </ul></li>
  </ul></li>
</ul>
</div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" autocomplete="off" autocorrect="off" autocapitalize="off" spellcheck="false"/>
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script>document.getElementById('searchbox').style.display = "block"</script>








        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="footer">
      &copy;2023, Ughur Mammadzada.
      
      |
      Powered by <a href="http://sphinx-doc.org/">Sphinx 7.2.6</a>
      &amp; <a href="https://github.com/bitprophet/alabaster">Alabaster 0.7.13</a>
      
    </div>

    

    
  </body>
</html>